/* ClockApplet.c generated by valac 0.56.17, the Vala compiler
 * generated from ClockApplet.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "clockapplet.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "plugin.h"
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <gio/gdesktopappinfo.h>
#include <libpeas/peas.h>

#define CLOCK_SETTINGS_SCHEMA "com.solus-project.clock"
#define GNOME_SETTINGS_SCHEMA "org.gnome.desktop.interface"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CLOCK_PLUGIN_0_PROPERTY,
	CLOCK_PLUGIN_NUM_PROPERTIES
};
static GParamSpec* clock_plugin_properties[CLOCK_PLUGIN_NUM_PROPERTIES];
enum  {
	CLOCK_APPLET_0_PROPERTY,
	CLOCK_APPLET_UUID_PROPERTY,
	CLOCK_APPLET_NUM_PROPERTIES
};
static GParamSpec* clock_applet_properties[CLOCK_APPLET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
enum  {
	CLOCK_SETTINGS_0_PROPERTY,
	CLOCK_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* clock_settings_properties[CLOCK_SETTINGS_NUM_PROPERTIES];

struct _ClockAppletPrivate {
	GDateTime* time;
	BudgiePopover* popover;
	GtkOrientation orient;
	BudgiePopoverManager* manager;
	gboolean clock_show_date;
	gboolean clock_show_seconds;
	gboolean clock_use_24_hour_time;
	gboolean clock_use_custom_format;
	gboolean clock_use_custom_timezone;
	gchar* clock_custom_format;
	GTimeZone* clock_timezone;
	gchar* _uuid;
};

struct _ClockSettingsPrivate {
	GtkSwitch* show_date;
	GtkSwitch* show_seconds;
	GtkSwitch* use_24_hour_time;
	GtkSwitch* use_custom_format;
	GtkEntry* custom_format;
	GtkSwitch* use_custom_timezone;
	GtkEntry* custom_timezone;
};

static gpointer clock_plugin_parent_class = NULL;
static BudgiePluginIface * clock_plugin_budgie_plugin_parent_iface = NULL;
static GType clock_plugin_type_id = 0;
static gint ClockApplet_private_offset;
static gpointer clock_applet_parent_class = NULL;
static GType clock_applet_type_id = 0;
static gint ClockSettings_private_offset;
static gpointer clock_settings_parent_class = NULL;
static GType clock_settings_type_id = 0;

static BudgieApplet* clock_plugin_real_get_panel_widget (BudgiePlugin* base,
                                                  const gchar* uuid);
static GtkButton* clock_applet_new_plain_button (ClockApplet* self,
                                          const gchar* label_str);
static void clock_applet_real_panel_position_changed (BudgieApplet* base,
                                               BudgiePanelPosition position);
static void clock_applet_on_date_activate (ClockApplet* self);
static void _clock_applet_on_date_activate_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static gboolean __lambda4_ (ClockApplet* self,
                     GdkEventButton* e);
static gboolean ___lambda4__gtk_widget_button_press_event (GtkWidget* _sender,
                                                    GdkEventButton* event,
                                                    gpointer self);
static void clock_applet_update_setting (ClockApplet* self,
                                  const gchar* schema,
                                  const gchar* key);
static gboolean _clock_applet_update_clock_gsource_func (gpointer self);
static void __lambda5_ (ClockApplet* self,
                 const gchar* key);
static void ___lambda5__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
static void __lambda6_ (ClockApplet* self,
                 const gchar* key);
static void ___lambda6__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
static void clock_applet_real_update_popovers (BudgieApplet* base,
                                        BudgiePopoverManager* manager);
static gboolean clock_applet_real_supports_settings (BudgieApplet* base);
static GtkWidget* clock_applet_real_get_settings_ui (BudgieApplet* base);
static void clock_applet_finalize (GObject * obj);
static void _vala_clock_applet_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_clock_applet_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static gboolean __lambda7_ (GValue* value,
                     GVariant* variant,
                     void* user_data);
static gboolean ___lambda7__gsettings_bind_get_mapping (GValue* value,
                                                 GVariant* variant,
                                                 void* user_data);
static GVariant* __lambda8_ (GValue* value,
                      const GVariantType* expected_type,
                      void* user_data);
static GVariant* ___lambda8__gsettings_bind_set_mapping (GValue* value,
                                                  const GVariantType* expected_type,
                                                  void* user_data);
static void clock_settings_updateSensitve (ClockSettings* self);
static void _clock_settings_updateSensitve_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void clock_settings_finalize (GObject * obj);

static BudgieApplet*
clock_plugin_real_get_panel_widget (BudgiePlugin* base,
                                    const gchar* uuid)
{
	ClockPlugin * self;
	ClockApplet* _tmp0_;
	BudgieApplet* result;
#line 13 "../src/panel/applets/clock/ClockApplet.vala"
	self = (ClockPlugin*) base;
#line 13 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 14 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp0_ = clock_applet_new (uuid);
#line 14 "../src/panel/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp0_);
#line 14 "../src/panel/applets/clock/ClockApplet.vala"
	result = (BudgieApplet*) _tmp0_;
#line 14 "../src/panel/applets/clock/ClockApplet.vala"
	return result;
#line 176 "ClockApplet.c"
}

ClockPlugin*
clock_plugin_construct (GType object_type)
{
	ClockPlugin * self = NULL;
#line 12 "../src/panel/applets/clock/ClockApplet.vala"
	self = (ClockPlugin*) g_object_new (object_type, NULL);
#line 12 "../src/panel/applets/clock/ClockApplet.vala"
	return self;
#line 187 "ClockApplet.c"
}

ClockPlugin*
clock_plugin_new (void)
{
#line 12 "../src/panel/applets/clock/ClockApplet.vala"
	return clock_plugin_construct (TYPE_CLOCK_PLUGIN);
#line 195 "ClockApplet.c"
}

static void
clock_plugin_class_init (ClockPluginClass * klass,
                         gpointer klass_data)
{
#line 12 "../src/panel/applets/clock/ClockApplet.vala"
	clock_plugin_parent_class = g_type_class_peek_parent (klass);
#line 204 "ClockApplet.c"
}

static void
clock_plugin_budgie_plugin_interface_init (BudgiePluginIface * iface,
                                           gpointer iface_data)
{
#line 12 "../src/panel/applets/clock/ClockApplet.vala"
	clock_plugin_budgie_plugin_parent_iface = g_type_interface_peek_parent (iface);
#line 12 "../src/panel/applets/clock/ClockApplet.vala"
	iface->get_panel_widget = (BudgieApplet* (*) (BudgiePlugin*, const gchar*)) clock_plugin_real_get_panel_widget;
#line 215 "ClockApplet.c"
}

static void
clock_plugin_instance_init (ClockPlugin * self,
                            gpointer klass)
{
}

GType
clock_plugin_get_type (void)
{
	return clock_plugin_type_id;
}

GType
clock_plugin_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClockPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClockPlugin), 0, (GInstanceInitFunc) clock_plugin_instance_init, NULL };
	static const GInterfaceInfo budgie_plugin_info = { (GInterfaceInitFunc) clock_plugin_budgie_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	clock_plugin_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "ClockPlugin", &g_define_type_info, 0);
	g_type_module_add_interface (module, clock_plugin_type_id, budgie_plugin_get_type (), &budgie_plugin_info);
	return clock_plugin_type_id;
}

static inline gpointer
clock_applet_get_instance_private (ClockApplet* self)
{
	return G_STRUCT_MEMBER_P (self, ClockApplet_private_offset);
}

static GtkButton*
clock_applet_new_plain_button (ClockApplet* self,
                               const gchar* label_str)
{
	GtkButton* ret = NULL;
	GtkButton* _tmp0_;
	GtkWidget* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkButton* result;
#line 49 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (label_str != NULL, NULL);
#line 50 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_with_label (label_str);
#line 50 "../src/panel/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp0_);
#line 50 "../src/panel/applets/clock/ClockApplet.vala"
	ret = _tmp0_;
#line 51 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) ret);
#line 51 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_set_halign (_tmp1_, GTK_ALIGN_START);
#line 52 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) ret);
#line 52 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_style_context_add_class (_tmp2_, GTK_STYLE_CLASS_FLAT);
#line 53 "../src/panel/applets/clock/ClockApplet.vala"
	result = ret;
#line 53 "../src/panel/applets/clock/ClockApplet.vala"
	return result;
#line 277 "ClockApplet.c"
}

static void
clock_applet_real_panel_position_changed (BudgieApplet* base,
                                          BudgiePanelPosition position)
{
	ClockApplet * self;
	gboolean _tmp0_ = FALSE;
	GtkLabel* _tmp5_;
	GtkBox* _tmp6_;
#line 57 "../src/panel/applets/clock/ClockApplet.vala"
	self = (ClockApplet*) base;
#line 58 "../src/panel/applets/clock/ClockApplet.vala"
	if (position == BUDGIE_PANEL_POSITION_LEFT) {
#line 58 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp0_ = TRUE;
#line 294 "ClockApplet.c"
	} else {
#line 58 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp0_ = position == BUDGIE_PANEL_POSITION_RIGHT;
#line 298 "ClockApplet.c"
	}
#line 58 "../src/panel/applets/clock/ClockApplet.vala"
	if (_tmp0_) {
#line 302 "ClockApplet.c"
		GtkLabel* _tmp1_;
		GtkLabel* _tmp2_;
#line 59 "../src/panel/applets/clock/ClockApplet.vala"
		self->priv->orient = GTK_ORIENTATION_VERTICAL;
#line 60 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp1_ = self->clock_label;
#line 60 "../src/panel/applets/clock/ClockApplet.vala"
		gtk_label_set_line_wrap (_tmp1_, TRUE);
#line 61 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp2_ = self->clock_label;
#line 61 "../src/panel/applets/clock/ClockApplet.vala"
		gtk_label_set_max_width_chars (_tmp2_, 1);
#line 315 "ClockApplet.c"
	} else {
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
#line 63 "../src/panel/applets/clock/ClockApplet.vala"
		self->priv->orient = GTK_ORIENTATION_HORIZONTAL;
#line 64 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp3_ = self->clock_label;
#line 64 "../src/panel/applets/clock/ClockApplet.vala"
		gtk_label_set_line_wrap (_tmp3_, FALSE);
#line 65 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp4_ = self->clock_label;
#line 65 "../src/panel/applets/clock/ClockApplet.vala"
		gtk_label_set_max_width_chars (_tmp4_, -1);
#line 329 "ClockApplet.c"
	}
#line 67 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp5_ = self->seconds_label;
#line 67 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_label_set_text (_tmp5_, "");
#line 68 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp6_ = self->layout;
#line 68 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp6_, self->priv->orient);
#line 69 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_update_clock (self);
#line 341 "ClockApplet.c"
}

static void
_clock_applet_on_date_activate_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 123 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_on_date_activate ((ClockApplet*) self);
#line 350 "ClockApplet.c"
}

static gboolean
__lambda4_ (ClockApplet* self,
            GdkEventButton* e)
{
	BudgiePopover* _tmp0_;
	gboolean result;
#line 127 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 128 "../src/panel/applets/clock/ClockApplet.vala"
	if (e->button != ((guint) 1)) {
#line 129 "../src/panel/applets/clock/ClockApplet.vala"
		result = GDK_EVENT_PROPAGATE;
#line 129 "../src/panel/applets/clock/ClockApplet.vala"
		return result;
#line 367 "ClockApplet.c"
	}
#line 131 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->popover;
#line 131 "../src/panel/applets/clock/ClockApplet.vala"
	if (gtk_widget_get_visible ((GtkWidget*) _tmp0_)) {
#line 373 "ClockApplet.c"
		BudgiePopover* _tmp1_;
#line 132 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp1_ = self->priv->popover;
#line 132 "../src/panel/applets/clock/ClockApplet.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 379 "ClockApplet.c"
	} else {
		BudgiePopoverManager* _tmp2_;
		GtkEventBox* _tmp3_;
#line 134 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp2_ = self->priv->manager;
#line 134 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp3_ = self->widget;
#line 134 "../src/panel/applets/clock/ClockApplet.vala"
		budgie_popover_manager_show_popover (_tmp2_, (GtkWidget*) _tmp3_);
#line 389 "ClockApplet.c"
	}
#line 136 "../src/panel/applets/clock/ClockApplet.vala"
	result = GDK_EVENT_STOP;
#line 136 "../src/panel/applets/clock/ClockApplet.vala"
	return result;
#line 395 "ClockApplet.c"
}

static gboolean
___lambda4__gtk_widget_button_press_event (GtkWidget* _sender,
                                           GdkEventButton* event,
                                           gpointer self)
{
	gboolean result;
	result = __lambda4_ ((ClockApplet*) self, event);
#line 127 "../src/panel/applets/clock/ClockApplet.vala"
	return result;
#line 407 "ClockApplet.c"
}

static gboolean
_clock_applet_update_clock_gsource_func (gpointer self)
{
	gboolean result;
	result = clock_applet_update_clock ((ClockApplet*) self);
#line 151 "../src/panel/applets/clock/ClockApplet.vala"
	return result;
#line 417 "ClockApplet.c"
}

static void
__lambda5_ (ClockApplet* self,
            const gchar* key)
{
#line 153 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_if_fail (key != NULL);
#line 154 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, CLOCK_SETTINGS_SCHEMA, key);
#line 155 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_update_clock (self);
#line 430 "ClockApplet.c"
}

static void
___lambda5__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
#line 153 "../src/panel/applets/clock/ClockApplet.vala"
	__lambda5_ ((ClockApplet*) self, key);
#line 440 "ClockApplet.c"
}

static void
__lambda6_ (ClockApplet* self,
            const gchar* key)
{
#line 157 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_if_fail (key != NULL);
#line 158 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, GNOME_SETTINGS_SCHEMA, key);
#line 159 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_update_clock (self);
#line 453 "ClockApplet.c"
}

static void
___lambda6__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
#line 157 "../src/panel/applets/clock/ClockApplet.vala"
	__lambda6_ ((ClockApplet*) self, key);
#line 463 "ClockApplet.c"
}

ClockApplet*
clock_applet_construct (GType object_type,
                        const gchar* uuid)
{
	ClockApplet * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkEventBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkEventBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkBox* _tmp9_;
	GtkLabel* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkBox* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkBox* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GtkLabel* _tmp25_;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkStyleContext* _tmp28_;
	GtkEventBox* _tmp29_;
	BudgiePopover* _tmp30_;
	GtkBox* container = NULL;
	GtkBox* _tmp31_;
	GtkStyleContext* _tmp32_;
	GtkBox* menu = NULL;
	GtkBox* _tmp33_;
	GtkStyleContext* _tmp34_;
	BudgiePopover* _tmp35_;
	GtkButton* time_button = NULL;
	GtkButton* _tmp36_;
	GtkEventBox* _tmp37_;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GSettings* _tmp40_;
	GSettings* _tmp41_;
	GtkEventBox* _tmp42_;
	BudgiePopover* _tmp43_;
	GtkWidget* _tmp44_;
#line 72 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 73 "../src/panel/applets/clock/ClockApplet.vala"
	self = (ClockApplet*) g_object_new (object_type, "uuid", uuid, NULL);
#line 75 "../src/panel/applets/clock/ClockApplet.vala"
	budgie_applet_set_settings_schema ((BudgieApplet*) self, CLOCK_SETTINGS_SCHEMA);
#line 76 "../src/panel/applets/clock/ClockApplet.vala"
	budgie_applet_set_settings_prefix ((BudgieApplet*) self, "/com/solus-project/clock/instance/clock");
#line 78 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp0_ = budgie_applet_get_applet_settings ((BudgieApplet*) self, uuid);
#line 78 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->settings);
#line 78 "../src/panel/applets/clock/ClockApplet.vala"
	self->settings = _tmp0_;
#line 79 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp1_ = g_settings_new (GNOME_SETTINGS_SCHEMA);
#line 79 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->gnome_settings);
#line 79 "../src/panel/applets/clock/ClockApplet.vala"
	self->gnome_settings = _tmp1_;
#line 81 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp2_ = (GtkEventBox*) gtk_event_box_new ();
#line 81 "../src/panel/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp2_);
#line 81 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->widget);
#line 81 "../src/panel/applets/clock/ClockApplet.vala"
	self->widget = _tmp2_;
#line 82 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 2);
#line 82 "../src/panel/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp3_);
#line 82 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->layout);
#line 82 "../src/panel/applets/clock/ClockApplet.vala"
	self->layout = _tmp3_;
#line 83 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp4_ = self->widget;
#line 83 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp5_ = self->layout;
#line 83 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 85 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp6_ = (GtkLabel*) gtk_label_new ("");
#line 85 "../src/panel/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp6_);
#line 85 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->clock_label);
#line 85 "../src/panel/applets/clock/ClockApplet.vala"
	self->clock_label = _tmp6_;
#line 86 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp7_ = self->clock_label;
#line 86 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_label_set_line_wrap (_tmp7_, TRUE);
#line 87 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp8_ = self->clock_label;
#line 87 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_label_set_justify (_tmp8_, GTK_JUSTIFY_CENTER);
#line 88 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp9_ = self->layout;
#line 88 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp10_ = self->clock_label;
#line 88 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp9_, (GtkWidget*) _tmp10_, FALSE, FALSE, (guint) 0);
#line 89 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp11_ = self->layout;
#line 89 "../src/panel/applets/clock/ClockApplet.vala"
	g_object_set ((GtkWidget*) _tmp11_, "margin", 0, NULL);
#line 90 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp12_ = self->layout;
#line 90 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp12_, (guint) 0);
#line 92 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp13_ = (GtkLabel*) gtk_label_new ("");
#line 92 "../src/panel/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp13_);
#line 92 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->seconds_label);
#line 92 "../src/panel/applets/clock/ClockApplet.vala"
	self->seconds_label = _tmp13_;
#line 93 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp14_ = self->seconds_label;
#line 93 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
#line 93 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_style_context_add_class (_tmp15_, "dim-label");
#line 94 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp16_ = self->layout;
#line 94 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp17_ = self->seconds_label;
#line 94 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp16_, (GtkWidget*) _tmp17_, FALSE, FALSE, (guint) 0);
#line 95 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp18_ = self->seconds_label;
#line 95 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp18_, TRUE);
#line 96 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp19_ = self->seconds_label;
#line 96 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp19_);
#line 98 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp20_ = (GtkLabel*) gtk_label_new ("");
#line 98 "../src/panel/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp20_);
#line 98 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->date_label);
#line 98 "../src/panel/applets/clock/ClockApplet.vala"
	self->date_label = _tmp20_;
#line 99 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp21_ = self->layout;
#line 99 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp22_ = self->date_label;
#line 99 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (_tmp21_, (GtkWidget*) _tmp22_, FALSE, FALSE, (guint) 0);
#line 100 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp23_ = self->date_label;
#line 100 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp23_, TRUE);
#line 101 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp24_ = self->date_label;
#line 101 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp24_);
#line 103 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp25_ = self->clock_label;
#line 103 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp25_, GTK_ALIGN_CENTER);
#line 104 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp26_ = self->seconds_label;
#line 104 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp26_, GTK_ALIGN_CENTER);
#line 105 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp27_ = self->date_label;
#line 105 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp27_, GTK_ALIGN_CENTER);
#line 107 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 107 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_style_context_add_class (_tmp28_, "budgie-clock-applet");
#line 110 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp29_ = self->widget;
#line 110 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp30_ = (BudgiePopover*) budgie_popover_new ((GtkWidget*) _tmp29_);
#line 110 "../src/panel/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp30_);
#line 110 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->popover);
#line 110 "../src/panel/applets/clock/ClockApplet.vala"
	self->priv->popover = _tmp30_;
#line 112 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp31_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 112 "../src/panel/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp31_);
#line 112 "../src/panel/applets/clock/ClockApplet.vala"
	container = _tmp31_;
#line 113 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp32_ = gtk_widget_get_style_context ((GtkWidget*) container);
#line 113 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_style_context_add_class (_tmp32_, "clock-applet-stack");
#line 114 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_box_set_homogeneous (container, TRUE);
#line 116 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp33_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 1);
#line 116 "../src/panel/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp33_);
#line 116 "../src/panel/applets/clock/ClockApplet.vala"
	menu = _tmp33_;
#line 117 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp34_ = gtk_widget_get_style_context ((GtkWidget*) menu);
#line 117 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_style_context_add_class (_tmp34_, "clock-applet-stack");
#line 118 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_container_set_border_width ((GtkContainer*) menu, (guint) 6);
#line 120 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp35_ = self->priv->popover;
#line 120 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_container_add ((GtkContainer*) _tmp35_, (GtkWidget*) menu);
#line 122 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp36_ = clock_applet_new_plain_button (self, _ ("System time and date settings"));
#line 122 "../src/panel/applets/clock/ClockApplet.vala"
	time_button = _tmp36_;
#line 123 "../src/panel/applets/clock/ClockApplet.vala"
	g_signal_connect_object (time_button, "clicked", (GCallback) _clock_applet_on_date_activate_gtk_button_clicked, self, 0);
#line 125 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_box_pack_start (menu, (GtkWidget*) time_button, FALSE, FALSE, (guint) 0);
#line 127 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp37_ = self->widget;
#line 127 "../src/panel/applets/clock/ClockApplet.vala"
	g_signal_connect_object ((GtkWidget*) _tmp37_, "button-press-event", (GCallback) ___lambda4__gtk_widget_button_press_event, self, 0);
#line 140 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, CLOCK_SETTINGS_SCHEMA, "show-date");
#line 141 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, CLOCK_SETTINGS_SCHEMA, "show-seconds");
#line 142 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, GNOME_SETTINGS_SCHEMA, "clock-format");
#line 143 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, CLOCK_SETTINGS_SCHEMA, "use-custom-format");
#line 144 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, CLOCK_SETTINGS_SCHEMA, "custom-format");
#line 145 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, CLOCK_SETTINGS_SCHEMA, "use-custom-timezone");
#line 146 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_update_setting (self, CLOCK_SETTINGS_SCHEMA, "custom-timezone");
#line 148 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp38_ = self->date_label;
#line 148 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp38_, self->priv->clock_show_date);
#line 149 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp39_ = self->seconds_label;
#line 149 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp39_, self->priv->clock_show_seconds);
#line 151 "../src/panel/applets/clock/ClockApplet.vala"
	g_timeout_add_seconds_full (G_PRIORITY_LOW, (guint) 1, _clock_applet_update_clock_gsource_func, g_object_ref (self), g_object_unref);
#line 153 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp40_ = self->settings;
#line 153 "../src/panel/applets/clock/ClockApplet.vala"
	g_signal_connect_object (_tmp40_, "changed", (GCallback) ___lambda5__g_settings_changed, self, 0);
#line 157 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp41_ = self->gnome_settings;
#line 157 "../src/panel/applets/clock/ClockApplet.vala"
	g_signal_connect_object (_tmp41_, "changed", (GCallback) ___lambda6__g_settings_changed, self, 0);
#line 162 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp42_ = self->widget;
#line 162 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp42_);
#line 164 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp43_ = self->priv->popover;
#line 164 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp44_ = gtk_bin_get_child ((GtkBin*) _tmp43_);
#line 164 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_show_all (_tmp44_);
#line 166 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 72 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (time_button);
#line 72 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (menu);
#line 72 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (container);
#line 72 "../src/panel/applets/clock/ClockApplet.vala"
	return self;
#line 759 "ClockApplet.c"
}

ClockApplet*
clock_applet_new (const gchar* uuid)
{
#line 72 "../src/panel/applets/clock/ClockApplet.vala"
	return clock_applet_construct (TYPE_CLOCK_APPLET, uuid);
#line 767 "ClockApplet.c"
}

static void
clock_applet_on_date_activate (ClockApplet* self)
{
	BudgiePopover* _tmp0_;
	GDesktopAppInfo* app_info = NULL;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 169 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->popover;
#line 170 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 171 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp1_ = g_desktop_app_info_new ("budgie-datetime-panel.desktop");
#line 171 "../src/panel/applets/clock/ClockApplet.vala"
	app_info = _tmp1_;
#line 173 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp2_ = app_info;
#line 173 "../src/panel/applets/clock/ClockApplet.vala"
	if (_tmp2_ == NULL) {
#line 174 "../src/panel/applets/clock/ClockApplet.vala"
		_g_object_unref0 (app_info);
#line 174 "../src/panel/applets/clock/ClockApplet.vala"
		return;
#line 796 "ClockApplet.c"
	}
	{
		GDesktopAppInfo* _tmp3_;
#line 177 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp3_ = app_info;
#line 177 "../src/panel/applets/clock/ClockApplet.vala"
		g_app_info_launch ((GAppInfo*) _tmp3_, NULL, NULL, &_inner_error0_);
#line 177 "../src/panel/applets/clock/ClockApplet.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 806 "ClockApplet.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 176 "../src/panel/applets/clock/ClockApplet.vala"
		e = _inner_error0_;
#line 176 "../src/panel/applets/clock/ClockApplet.vala"
		_inner_error0_ = NULL;
#line 179 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp4_ = e;
#line 179 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp5_ = _tmp4_->message;
#line 179 "../src/panel/applets/clock/ClockApplet.vala"
		g_message ("ClockApplet.vala:179: Unable to launch budgie-datetime-panel.desktop: " \
"%s", _tmp5_);
#line 176 "../src/panel/applets/clock/ClockApplet.vala"
		_g_error_free0 (e);
#line 828 "ClockApplet.c"
	}
	__finally0:
#line 176 "../src/panel/applets/clock/ClockApplet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 176 "../src/panel/applets/clock/ClockApplet.vala"
		_g_object_unref0 (app_info);
#line 176 "../src/panel/applets/clock/ClockApplet.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 176 "../src/panel/applets/clock/ClockApplet.vala"
		g_clear_error (&_inner_error0_);
#line 176 "../src/panel/applets/clock/ClockApplet.vala"
		return;
#line 841 "ClockApplet.c"
	}
#line 169 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (app_info);
#line 845 "ClockApplet.c"
}

static void
clock_applet_real_update_popovers (BudgieApplet* base,
                                   BudgiePopoverManager* manager)
{
	ClockApplet * self;
	GtkEventBox* _tmp0_;
	BudgiePopover* _tmp1_;
#line 183 "../src/panel/applets/clock/ClockApplet.vala"
	self = (ClockApplet*) base;
#line 184 "../src/panel/applets/clock/ClockApplet.vala"
	self->priv->manager = manager;
#line 185 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp0_ = self->widget;
#line 185 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->popover;
#line 185 "../src/panel/applets/clock/ClockApplet.vala"
	budgie_popover_manager_register_popover (manager, (GtkWidget*) _tmp0_, _tmp1_);
#line 865 "ClockApplet.c"
}

static GTimeZone*
vala_g_time_zone_new_identifier (const gchar* identifier,
                                 GError** error)
{
	GTimeZone* self;
	GError* _inner_error0_ = NULL;
#line 3432 "glib-2.0.vapi"
	self = (GTimeZone*) g_time_zone_new_identifier (identifier);
#line 3433 "glib-2.0.vapi"
	if (((GTimeZone*) self) == NULL) {
#line 878 "ClockApplet.c"
		GError* _tmp0_;
#line 3434 "glib-2.0.vapi"
		_tmp0_ = g_error_new_literal (G_CONVERT_ERROR, G_CONVERT_ERROR_ILLEGAL_SEQUENCE, "Invalid identifier argument");
#line 3434 "glib-2.0.vapi"
		_inner_error0_ = _tmp0_;
#line 3434 "glib-2.0.vapi"
		g_propagate_error (error, _inner_error0_);
#line 3434 "glib-2.0.vapi"
		_g_time_zone_unref0 (self);
#line 3434 "glib-2.0.vapi"
		return NULL;
#line 890 "ClockApplet.c"
	}
#line 3431 "glib-2.0.vapi"
	return self;
#line 894 "ClockApplet.c"
}

static void
clock_applet_update_setting (ClockApplet* self,
                             const gchar* schema,
                             const gchar* key)
{
	GError* _inner_error0_ = NULL;
#line 188 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_if_fail (schema != NULL);
#line 188 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_if_fail (key != NULL);
#line 189 "../src/panel/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (schema, CLOCK_SETTINGS_SCHEMA) == 0) {
#line 911 "ClockApplet.c"
		const gchar* _tmp0_;
		GQuark _tmp2_ = 0U;
#line 190 "../src/panel/applets/clock/ClockApplet.vala"
		static GQuark _tmp1_label0 = 0;
#line 190 "../src/panel/applets/clock/ClockApplet.vala"
		static GQuark _tmp1_label1 = 0;
#line 190 "../src/panel/applets/clock/ClockApplet.vala"
		static GQuark _tmp1_label2 = 0;
#line 190 "../src/panel/applets/clock/ClockApplet.vala"
		static GQuark _tmp1_label3 = 0;
#line 190 "../src/panel/applets/clock/ClockApplet.vala"
		static GQuark _tmp1_label4 = 0;
#line 190 "../src/panel/applets/clock/ClockApplet.vala"
		static GQuark _tmp1_label5 = 0;
#line 190 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp0_ = key;
#line 190 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 190 "../src/panel/applets/clock/ClockApplet.vala"
		if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("show-date")))) {
#line 190 "../src/panel/applets/clock/ClockApplet.vala"
			switch (0) {
#line 934 "ClockApplet.c"
				default:
				{
					GSettings* _tmp3_;
					GtkLabel* _tmp4_;
#line 192 "../src/panel/applets/clock/ClockApplet.vala"
					_tmp3_ = self->settings;
#line 192 "../src/panel/applets/clock/ClockApplet.vala"
					self->priv->clock_show_date = g_settings_get_boolean (_tmp3_, key);
#line 193 "../src/panel/applets/clock/ClockApplet.vala"
					_tmp4_ = self->date_label;
#line 193 "../src/panel/applets/clock/ClockApplet.vala"
					gtk_widget_set_visible ((GtkWidget*) _tmp4_, self->priv->clock_show_date);
#line 194 "../src/panel/applets/clock/ClockApplet.vala"
					break;
#line 949 "ClockApplet.c"
				}
			}
		} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("show-seconds")))) {
#line 190 "../src/panel/applets/clock/ClockApplet.vala"
			switch (0) {
#line 955 "ClockApplet.c"
				default:
				{
					GSettings* _tmp5_;
					GtkLabel* _tmp6_;
#line 196 "../src/panel/applets/clock/ClockApplet.vala"
					_tmp5_ = self->settings;
#line 196 "../src/panel/applets/clock/ClockApplet.vala"
					self->priv->clock_show_seconds = g_settings_get_boolean (_tmp5_, key);
#line 197 "../src/panel/applets/clock/ClockApplet.vala"
					_tmp6_ = self->seconds_label;
#line 197 "../src/panel/applets/clock/ClockApplet.vala"
					gtk_widget_set_visible ((GtkWidget*) _tmp6_, self->priv->clock_show_seconds);
#line 198 "../src/panel/applets/clock/ClockApplet.vala"
					break;
#line 970 "ClockApplet.c"
				}
			}
		} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("use-custom-format")))) {
#line 190 "../src/panel/applets/clock/ClockApplet.vala"
			switch (0) {
#line 976 "ClockApplet.c"
				default:
				{
					GSettings* _tmp7_;
#line 200 "../src/panel/applets/clock/ClockApplet.vala"
					_tmp7_ = self->settings;
#line 200 "../src/panel/applets/clock/ClockApplet.vala"
					self->priv->clock_use_custom_format = g_settings_get_boolean (_tmp7_, key);
#line 201 "../src/panel/applets/clock/ClockApplet.vala"
					if (self->priv->clock_use_custom_format) {
#line 986 "ClockApplet.c"
						GtkLabel* _tmp8_;
						GtkLabel* _tmp9_;
#line 202 "../src/panel/applets/clock/ClockApplet.vala"
						_tmp8_ = self->date_label;
#line 202 "../src/panel/applets/clock/ClockApplet.vala"
						gtk_widget_set_visible ((GtkWidget*) _tmp8_, FALSE);
#line 203 "../src/panel/applets/clock/ClockApplet.vala"
						_tmp9_ = self->seconds_label;
#line 203 "../src/panel/applets/clock/ClockApplet.vala"
						gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
#line 997 "ClockApplet.c"
					} else {
						GtkLabel* _tmp10_;
						GtkLabel* _tmp11_;
#line 205 "../src/panel/applets/clock/ClockApplet.vala"
						_tmp10_ = self->date_label;
#line 205 "../src/panel/applets/clock/ClockApplet.vala"
						gtk_widget_set_visible ((GtkWidget*) _tmp10_, self->priv->clock_show_date);
#line 206 "../src/panel/applets/clock/ClockApplet.vala"
						_tmp11_ = self->seconds_label;
#line 206 "../src/panel/applets/clock/ClockApplet.vala"
						gtk_widget_set_visible ((GtkWidget*) _tmp11_, self->priv->clock_show_seconds);
#line 1009 "ClockApplet.c"
					}
#line 208 "../src/panel/applets/clock/ClockApplet.vala"
					break;
#line 1013 "ClockApplet.c"
				}
			}
		} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("custom-format")))) {
#line 190 "../src/panel/applets/clock/ClockApplet.vala"
			switch (0) {
#line 1019 "ClockApplet.c"
				default:
				{
					GSettings* _tmp12_;
					gchar* _tmp13_;
#line 210 "../src/panel/applets/clock/ClockApplet.vala"
					_tmp12_ = self->settings;
#line 210 "../src/panel/applets/clock/ClockApplet.vala"
					_tmp13_ = g_settings_get_string (_tmp12_, key);
#line 210 "../src/panel/applets/clock/ClockApplet.vala"
					_g_free0 (self->priv->clock_custom_format);
#line 210 "../src/panel/applets/clock/ClockApplet.vala"
					self->priv->clock_custom_format = _tmp13_;
#line 211 "../src/panel/applets/clock/ClockApplet.vala"
					break;
#line 1034 "ClockApplet.c"
				}
			}
		} else if ((_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("use-custom-timezone")))) || (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("custom-timezone"))))) {
#line 190 "../src/panel/applets/clock/ClockApplet.vala"
			switch (0) {
#line 1040 "ClockApplet.c"
				default:
				{
					GSettings* _tmp14_;
#line 214 "../src/panel/applets/clock/ClockApplet.vala"
					_tmp14_ = self->settings;
#line 214 "../src/panel/applets/clock/ClockApplet.vala"
					self->priv->clock_use_custom_timezone = g_settings_get_boolean (_tmp14_, "use-custom-timezone");
#line 215 "../src/panel/applets/clock/ClockApplet.vala"
					if (self->priv->clock_use_custom_timezone) {
#line 1050 "ClockApplet.c"
						gchar* custom_tz = NULL;
						GSettings* _tmp15_;
						gchar* _tmp16_;
#line 216 "../src/panel/applets/clock/ClockApplet.vala"
						_tmp15_ = self->settings;
#line 216 "../src/panel/applets/clock/ClockApplet.vala"
						_tmp16_ = g_settings_get_string (_tmp15_, "custom-timezone");
#line 216 "../src/panel/applets/clock/ClockApplet.vala"
						custom_tz = _tmp16_;
#line 1060 "ClockApplet.c"
						{
							GTimeZone* _tmp17_ = NULL;
							const gchar* _tmp18_;
							GTimeZone* _tmp19_;
							GTimeZone* _tmp20_;
#line 218 "../src/panel/applets/clock/ClockApplet.vala"
							_tmp18_ = custom_tz;
#line 218 "../src/panel/applets/clock/ClockApplet.vala"
							_tmp19_ = vala_g_time_zone_new_identifier (_tmp18_, &_inner_error0_);
#line 218 "../src/panel/applets/clock/ClockApplet.vala"
							_tmp17_ = _tmp19_;
#line 218 "../src/panel/applets/clock/ClockApplet.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1074 "ClockApplet.c"
								goto __catch0_g_error;
							}
#line 218 "../src/panel/applets/clock/ClockApplet.vala"
							_tmp20_ = _tmp17_;
#line 218 "../src/panel/applets/clock/ClockApplet.vala"
							_tmp17_ = NULL;
#line 218 "../src/panel/applets/clock/ClockApplet.vala"
							_g_time_zone_unref0 (self->priv->clock_timezone);
#line 218 "../src/panel/applets/clock/ClockApplet.vala"
							self->priv->clock_timezone = _tmp20_;
#line 217 "../src/panel/applets/clock/ClockApplet.vala"
							_g_time_zone_unref0 (_tmp17_);
#line 1087 "ClockApplet.c"
						}
						goto __finally0;
						__catch0_g_error:
						{
							const gchar* _tmp21_;
							GTimeZone* _tmp22_;
#line 217 "../src/panel/applets/clock/ClockApplet.vala"
							g_clear_error (&_inner_error0_);
#line 220 "../src/panel/applets/clock/ClockApplet.vala"
							_tmp21_ = custom_tz;
#line 220 "../src/panel/applets/clock/ClockApplet.vala"
							g_warning ("ClockApplet.vala:220: Clock applet: Failed to set time zone from ident" \
"ifier %s. Using UTC instead.", _tmp21_);
#line 221 "../src/panel/applets/clock/ClockApplet.vala"
							_tmp22_ = g_time_zone_new_utc ();
#line 221 "../src/panel/applets/clock/ClockApplet.vala"
							_g_time_zone_unref0 (self->priv->clock_timezone);
#line 221 "../src/panel/applets/clock/ClockApplet.vala"
							self->priv->clock_timezone = _tmp22_;
#line 1106 "ClockApplet.c"
						}
						__finally0:
#line 217 "../src/panel/applets/clock/ClockApplet.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 217 "../src/panel/applets/clock/ClockApplet.vala"
							_g_free0 (custom_tz);
#line 217 "../src/panel/applets/clock/ClockApplet.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 217 "../src/panel/applets/clock/ClockApplet.vala"
							g_clear_error (&_inner_error0_);
#line 217 "../src/panel/applets/clock/ClockApplet.vala"
							return;
#line 1119 "ClockApplet.c"
						}
#line 215 "../src/panel/applets/clock/ClockApplet.vala"
						_g_free0 (custom_tz);
#line 1123 "ClockApplet.c"
					} else {
						GTimeZone* _tmp23_;
#line 224 "../src/panel/applets/clock/ClockApplet.vala"
						_tmp23_ = g_time_zone_new_local ();
#line 224 "../src/panel/applets/clock/ClockApplet.vala"
						_g_time_zone_unref0 (self->priv->clock_timezone);
#line 224 "../src/panel/applets/clock/ClockApplet.vala"
						self->priv->clock_timezone = _tmp23_;
#line 1132 "ClockApplet.c"
					}
#line 226 "../src/panel/applets/clock/ClockApplet.vala"
					break;
#line 1136 "ClockApplet.c"
				}
			}
		}
#line 228 "../src/panel/applets/clock/ClockApplet.vala"
		return;
#line 1142 "ClockApplet.c"
	}
#line 230 "../src/panel/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (schema, GNOME_SETTINGS_SCHEMA) == 0) {
#line 1146 "ClockApplet.c"
		const gchar* _tmp24_;
		GQuark _tmp26_ = 0U;
#line 231 "../src/panel/applets/clock/ClockApplet.vala"
		static GQuark _tmp25_label0 = 0;
#line 231 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp24_ = key;
#line 231 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp26_ = (NULL == _tmp24_) ? 0 : g_quark_from_string (_tmp24_);
#line 231 "../src/panel/applets/clock/ClockApplet.vala"
		if (_tmp26_ == ((0 != _tmp25_label0) ? _tmp25_label0 : (_tmp25_label0 = g_quark_from_static_string ("clock-format")))) {
#line 231 "../src/panel/applets/clock/ClockApplet.vala"
			switch (0) {
#line 1159 "ClockApplet.c"
				default:
				{
					GSettings* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
#line 233 "../src/panel/applets/clock/ClockApplet.vala"
					_tmp27_ = self->gnome_settings;
#line 233 "../src/panel/applets/clock/ClockApplet.vala"
					_tmp28_ = g_settings_get_string (_tmp27_, "clock-format");
#line 233 "../src/panel/applets/clock/ClockApplet.vala"
					_tmp29_ = _tmp28_;
#line 233 "../src/panel/applets/clock/ClockApplet.vala"
					self->priv->clock_use_24_hour_time = g_strcmp0 (_tmp29_, "24h") == 0;
#line 233 "../src/panel/applets/clock/ClockApplet.vala"
					_g_free0 (_tmp29_);
#line 234 "../src/panel/applets/clock/ClockApplet.vala"
					break;
#line 1177 "ClockApplet.c"
				}
			}
		}
#line 236 "../src/panel/applets/clock/ClockApplet.vala"
		return;
#line 1183 "ClockApplet.c"
	}
}

/**
 * Update the date if necessary
 */
void
clock_applet_update_date (ClockApplet* self)
{
	gboolean _tmp0_ = FALSE;
	gchar* ftime = NULL;
	gchar* old = NULL;
	GtkLabel* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* ctime = NULL;
	GDateTime* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GtkLabel* _tmp11_;
	const gchar* _tmp12_;
#line 244 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 245 "../src/panel/applets/clock/ClockApplet.vala"
	if (!self->priv->clock_show_date) {
#line 245 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp0_ = TRUE;
#line 1213 "ClockApplet.c"
	} else {
#line 245 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp0_ = self->priv->clock_use_custom_format;
#line 1217 "ClockApplet.c"
	}
#line 245 "../src/panel/applets/clock/ClockApplet.vala"
	if (_tmp0_) {
#line 246 "../src/panel/applets/clock/ClockApplet.vala"
		return;
#line 1223 "ClockApplet.c"
	}
#line 249 "../src/panel/applets/clock/ClockApplet.vala"
	if (self->priv->orient == GTK_ORIENTATION_HORIZONTAL) {
#line 1227 "ClockApplet.c"
		gchar* _tmp1_;
#line 250 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp1_ = g_strdup ("%x");
#line 250 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 250 "../src/panel/applets/clock/ClockApplet.vala"
		ftime = _tmp1_;
#line 1235 "ClockApplet.c"
	} else {
		gchar* _tmp2_;
#line 252 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp2_ = g_strdup ("<small>%b %d</small>");
#line 252 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 252 "../src/panel/applets/clock/ClockApplet.vala"
		ftime = _tmp2_;
#line 1244 "ClockApplet.c"
	}
#line 256 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp3_ = self->date_label;
#line 256 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp4_ = gtk_label_get_label (_tmp3_);
#line 256 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 256 "../src/panel/applets/clock/ClockApplet.vala"
	old = _tmp5_;
#line 257 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp6_ = self->priv->time;
#line 257 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp7_ = ftime;
#line 257 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp8_ = g_date_time_format (_tmp6_, _tmp7_);
#line 257 "../src/panel/applets/clock/ClockApplet.vala"
	ctime = _tmp8_;
#line 258 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp9_ = old;
#line 258 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp10_ = ctime;
#line 258 "../src/panel/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (_tmp9_, _tmp10_) == 0) {
#line 259 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (ctime);
#line 259 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (old);
#line 259 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 259 "../src/panel/applets/clock/ClockApplet.vala"
		return;
#line 1276 "ClockApplet.c"
	}
#line 261 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp11_ = self->date_label;
#line 261 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp12_ = ctime;
#line 261 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_label_set_markup (_tmp11_, _tmp12_);
#line 244 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (ctime);
#line 244 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (old);
#line 244 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (ftime);
#line 1290 "ClockApplet.c"
}

/**
 * Update the seconds if necessary
 */
void
clock_applet_update_seconds (ClockApplet* self)
{
	gboolean _tmp0_ = FALSE;
	gchar* ftime = NULL;
	gchar* old = NULL;
	GtkLabel* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* ctime = NULL;
	GDateTime* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GtkLabel* _tmp11_;
	const gchar* _tmp12_;
#line 267 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 268 "../src/panel/applets/clock/ClockApplet.vala"
	if (!self->priv->clock_show_seconds) {
#line 268 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp0_ = TRUE;
#line 1319 "ClockApplet.c"
	} else {
#line 268 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp0_ = self->priv->clock_use_custom_format;
#line 1323 "ClockApplet.c"
	}
#line 268 "../src/panel/applets/clock/ClockApplet.vala"
	if (_tmp0_) {
#line 269 "../src/panel/applets/clock/ClockApplet.vala"
		return;
#line 1329 "ClockApplet.c"
	}
#line 272 "../src/panel/applets/clock/ClockApplet.vala"
	if (self->priv->orient == GTK_ORIENTATION_HORIZONTAL) {
#line 1333 "ClockApplet.c"
		gchar* _tmp1_;
#line 273 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp1_ = g_strdup ("");
#line 273 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 273 "../src/panel/applets/clock/ClockApplet.vala"
		ftime = _tmp1_;
#line 1341 "ClockApplet.c"
	} else {
		gchar* _tmp2_;
#line 275 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp2_ = g_strdup ("<big>%S</big>");
#line 275 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 275 "../src/panel/applets/clock/ClockApplet.vala"
		ftime = _tmp2_;
#line 1350 "ClockApplet.c"
	}
#line 279 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp3_ = self->seconds_label;
#line 279 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp4_ = gtk_label_get_label (_tmp3_);
#line 279 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 279 "../src/panel/applets/clock/ClockApplet.vala"
	old = _tmp5_;
#line 280 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp6_ = self->priv->time;
#line 280 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp7_ = ftime;
#line 280 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp8_ = g_date_time_format (_tmp6_, _tmp7_);
#line 280 "../src/panel/applets/clock/ClockApplet.vala"
	ctime = _tmp8_;
#line 281 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp9_ = old;
#line 281 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp10_ = ctime;
#line 281 "../src/panel/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (_tmp9_, _tmp10_) == 0) {
#line 282 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (ctime);
#line 282 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (old);
#line 282 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 282 "../src/panel/applets/clock/ClockApplet.vala"
		return;
#line 1382 "ClockApplet.c"
	}
#line 285 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp11_ = self->seconds_label;
#line 285 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp12_ = ctime;
#line 285 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_label_set_markup (_tmp11_, _tmp12_);
#line 267 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (ctime);
#line 267 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (old);
#line 267 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (ftime);
#line 1396 "ClockApplet.c"
}

/**
 * This is called once every second, updating the time
 */
static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 1420 "ClockApplet.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1442 "ClockApplet.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1446 "ClockApplet.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1452 "ClockApplet.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1456 "ClockApplet.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1460 "ClockApplet.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1468 "ClockApplet.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1496 "ClockApplet.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1505 "ClockApplet.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1519 "ClockApplet.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1528 "ClockApplet.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1542 "ClockApplet.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1551 "ClockApplet.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1560 "ClockApplet.c"
}

gboolean
clock_applet_update_clock (ClockApplet* self)
{
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	gchar* format = NULL;
	gchar* old = NULL;
	GtkLabel* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* ctime = NULL;
	GDateTime* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* ftime = NULL;
	gchar* formatted = NULL;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	GtkLabel* _tmp31_;
	const gchar* _tmp32_;
	gboolean result;
#line 291 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 292 "../src/panel/applets/clock/ClockApplet.vala"
	if (!self->priv->clock_use_custom_timezone) {
#line 1597 "ClockApplet.c"
		GTimeZone* _tmp0_;
#line 293 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp0_ = g_time_zone_new_local ();
#line 293 "../src/panel/applets/clock/ClockApplet.vala"
		_g_time_zone_unref0 (self->priv->clock_timezone);
#line 293 "../src/panel/applets/clock/ClockApplet.vala"
		self->priv->clock_timezone = _tmp0_;
#line 1605 "ClockApplet.c"
	}
#line 295 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->clock_timezone;
#line 295 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp2_ = g_date_time_new_now (_tmp1_);
#line 295 "../src/panel/applets/clock/ClockApplet.vala"
	_g_date_time_unref0 (self->priv->time);
#line 295 "../src/panel/applets/clock/ClockApplet.vala"
	self->priv->time = _tmp2_;
#line 298 "../src/panel/applets/clock/ClockApplet.vala"
	if (!self->priv->clock_use_custom_format) {
#line 1617 "ClockApplet.c"
		const gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
#line 299 "../src/panel/applets/clock/ClockApplet.vala"
		if (self->priv->clock_use_24_hour_time) {
#line 299 "../src/panel/applets/clock/ClockApplet.vala"
			_tmp3_ = "%H:%M";
#line 1625 "ClockApplet.c"
		} else {
#line 299 "../src/panel/applets/clock/ClockApplet.vala"
			_tmp3_ = "%l:%M";
#line 1629 "ClockApplet.c"
		}
#line 299 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 299 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (format);
#line 299 "../src/panel/applets/clock/ClockApplet.vala"
		format = _tmp4_;
#line 301 "../src/panel/applets/clock/ClockApplet.vala"
		if (self->priv->orient == GTK_ORIENTATION_HORIZONTAL) {
#line 301 "../src/panel/applets/clock/ClockApplet.vala"
			_tmp5_ = self->priv->clock_show_seconds;
#line 1641 "ClockApplet.c"
		} else {
#line 301 "../src/panel/applets/clock/ClockApplet.vala"
			_tmp5_ = FALSE;
#line 1645 "ClockApplet.c"
		}
#line 301 "../src/panel/applets/clock/ClockApplet.vala"
		if (_tmp5_) {
#line 1649 "ClockApplet.c"
			const gchar* _tmp6_;
			gchar* _tmp7_;
#line 302 "../src/panel/applets/clock/ClockApplet.vala"
			_tmp6_ = format;
#line 302 "../src/panel/applets/clock/ClockApplet.vala"
			_tmp7_ = g_strconcat (_tmp6_, ":%S", NULL);
#line 302 "../src/panel/applets/clock/ClockApplet.vala"
			_g_free0 (format);
#line 302 "../src/panel/applets/clock/ClockApplet.vala"
			format = _tmp7_;
#line 1660 "ClockApplet.c"
		}
#line 305 "../src/panel/applets/clock/ClockApplet.vala"
		if (!self->priv->clock_use_24_hour_time) {
#line 1664 "ClockApplet.c"
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 306 "../src/panel/applets/clock/ClockApplet.vala"
			_tmp8_ = format;
#line 306 "../src/panel/applets/clock/ClockApplet.vala"
			_tmp9_ = g_strconcat (_tmp8_, " %p", NULL);
#line 306 "../src/panel/applets/clock/ClockApplet.vala"
			_g_free0 (format);
#line 306 "../src/panel/applets/clock/ClockApplet.vala"
			format = _tmp9_;
#line 1675 "ClockApplet.c"
		}
	} else {
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 309 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp10_ = self->priv->clock_custom_format;
#line 309 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 309 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (format);
#line 309 "../src/panel/applets/clock/ClockApplet.vala"
		format = _tmp11_;
#line 1688 "ClockApplet.c"
	}
#line 312 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_update_date (self);
#line 313 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_update_seconds (self);
#line 316 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp12_ = self->clock_label;
#line 316 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp13_ = gtk_label_get_label (_tmp12_);
#line 316 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 316 "../src/panel/applets/clock/ClockApplet.vala"
	old = _tmp14_;
#line 317 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp15_ = self->priv->time;
#line 317 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp16_ = format;
#line 317 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp17_ = g_date_time_format (_tmp15_, _tmp16_);
#line 317 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp18_ = _tmp17_;
#line 317 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp19_ = string_strip (_tmp18_);
#line 317 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp20_ = _tmp19_;
#line 317 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (_tmp18_);
#line 317 "../src/panel/applets/clock/ClockApplet.vala"
	ctime = _tmp20_;
#line 320 "../src/panel/applets/clock/ClockApplet.vala"
	if (self->priv->orient == GTK_ORIENTATION_HORIZONTAL) {
#line 1720 "ClockApplet.c"
		gchar* _tmp21_;
#line 321 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp21_ = g_strdup ("%s");
#line 321 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 321 "../src/panel/applets/clock/ClockApplet.vala"
		ftime = _tmp21_;
#line 1728 "ClockApplet.c"
	} else {
		gchar* _tmp22_;
#line 323 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp22_ = g_strdup ("<small>%s</small>");
#line 323 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 323 "../src/panel/applets/clock/ClockApplet.vala"
		ftime = _tmp22_;
#line 1737 "ClockApplet.c"
	}
#line 326 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp23_ = ftime;
#line 326 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp24_ = ctime;
#line 326 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp25_ = g_strdup_printf (_tmp23_, _tmp24_);
#line 326 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp26_ = _tmp25_;
#line 326 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp27_ = string_replace (_tmp26_, "\u2007", "");
#line 326 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp28_ = _tmp27_;
#line 326 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (_tmp26_);
#line 326 "../src/panel/applets/clock/ClockApplet.vala"
	formatted = _tmp28_;
#line 327 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp29_ = old;
#line 327 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp30_ = formatted;
#line 327 "../src/panel/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (_tmp29_, _tmp30_) == 0) {
#line 328 "../src/panel/applets/clock/ClockApplet.vala"
		result = TRUE;
#line 328 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (formatted);
#line 328 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (ftime);
#line 328 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (ctime);
#line 328 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (old);
#line 328 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (format);
#line 328 "../src/panel/applets/clock/ClockApplet.vala"
		return result;
#line 1775 "ClockApplet.c"
	}
#line 331 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp31_ = self->clock_label;
#line 331 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp32_ = formatted;
#line 331 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_label_set_markup (_tmp31_, _tmp32_);
#line 332 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 334 "../src/panel/applets/clock/ClockApplet.vala"
	result = TRUE;
#line 334 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (formatted);
#line 334 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (ftime);
#line 334 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (ctime);
#line 334 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (old);
#line 334 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (format);
#line 334 "../src/panel/applets/clock/ClockApplet.vala"
	return result;
#line 1799 "ClockApplet.c"
}

static gboolean
clock_applet_real_supports_settings (BudgieApplet* base)
{
	ClockApplet * self;
	gboolean result;
#line 337 "../src/panel/applets/clock/ClockApplet.vala"
	self = (ClockApplet*) base;
#line 338 "../src/panel/applets/clock/ClockApplet.vala"
	result = TRUE;
#line 338 "../src/panel/applets/clock/ClockApplet.vala"
	return result;
#line 1813 "ClockApplet.c"
}

static GtkWidget*
clock_applet_real_get_settings_ui (BudgieApplet* base)
{
	ClockApplet * self;
	const gchar* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	ClockSettings* _tmp5_;
	GtkWidget* _tmp6_;
	GtkWidget* result;
#line 341 "../src/panel/applets/clock/ClockApplet.vala"
	self = (ClockApplet*) base;
#line 342 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->_uuid;
#line 342 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp1_ = budgie_applet_get_applet_settings ((BudgieApplet*) self, _tmp0_);
#line 342 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp2_ = _tmp1_;
#line 342 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp3_ = g_settings_new (GNOME_SETTINGS_SCHEMA);
#line 342 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp4_ = _tmp3_;
#line 342 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp5_ = clock_settings_new (_tmp2_, _tmp4_);
#line 342 "../src/panel/applets/clock/ClockApplet.vala"
	g_object_ref_sink (_tmp5_);
#line 342 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp6_ = (GtkWidget*) _tmp5_;
#line 342 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (_tmp4_);
#line 342 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (_tmp2_);
#line 342 "../src/panel/applets/clock/ClockApplet.vala"
	result = _tmp6_;
#line 342 "../src/panel/applets/clock/ClockApplet.vala"
	return result;
#line 1854 "ClockApplet.c"
}

const gchar*
clock_applet_get_uuid (ClockApplet* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 47 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->_uuid;
#line 47 "../src/panel/applets/clock/ClockApplet.vala"
	result = _tmp0_;
#line 47 "../src/panel/applets/clock/ClockApplet.vala"
	return result;
#line 1870 "ClockApplet.c"
}

void
clock_applet_set_uuid (ClockApplet* self,
                       const gchar* value)
{
	gchar* old_value;
#line 47 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/panel/applets/clock/ClockApplet.vala"
	old_value = clock_applet_get_uuid (self);
#line 47 "../src/panel/applets/clock/ClockApplet.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1884 "ClockApplet.c"
		gchar* _tmp0_;
#line 47 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp0_ = g_strdup (value);
#line 47 "../src/panel/applets/clock/ClockApplet.vala"
		_g_free0 (self->priv->_uuid);
#line 47 "../src/panel/applets/clock/ClockApplet.vala"
		self->priv->_uuid = _tmp0_;
#line 47 "../src/panel/applets/clock/ClockApplet.vala"
		g_object_notify_by_pspec ((GObject *) self, clock_applet_properties[CLOCK_APPLET_UUID_PROPERTY]);
#line 1894 "ClockApplet.c"
	}
}

static void
clock_applet_class_init (ClockAppletClass * klass,
                         gpointer klass_data)
{
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	g_type_class_adjust_private_offset (klass, &ClockApplet_private_offset);
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	((BudgieAppletClass *) klass)->panel_position_changed = (void (*) (BudgieApplet*, BudgiePanelPosition)) clock_applet_real_panel_position_changed;
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	((BudgieAppletClass *) klass)->update_popovers = (void (*) (BudgieApplet*, BudgiePopoverManager*)) clock_applet_real_update_popovers;
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	((BudgieAppletClass *) klass)->supports_settings = (gboolean (*) (BudgieApplet*)) clock_applet_real_supports_settings;
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	((BudgieAppletClass *) klass)->get_settings_ui = (GtkWidget* (*) (BudgieApplet*)) clock_applet_real_get_settings_ui;
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_clock_applet_get_property;
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_clock_applet_set_property;
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	G_OBJECT_CLASS (klass)->finalize = clock_applet_finalize;
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOCK_APPLET_UUID_PROPERTY, clock_applet_properties[CLOCK_APPLET_UUID_PROPERTY] = g_param_spec_string ("uuid", "uuid", "uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1922 "ClockApplet.c"
}

static void
clock_applet_instance_init (ClockApplet * self,
                            gpointer klass)
{
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	self->priv = clock_applet_get_instance_private (self);
#line 33 "../src/panel/applets/clock/ClockApplet.vala"
	self->priv->popover = NULL;
#line 35 "../src/panel/applets/clock/ClockApplet.vala"
	self->priv->orient = GTK_ORIENTATION_HORIZONTAL;
#line 37 "../src/panel/applets/clock/ClockApplet.vala"
	self->priv->manager = NULL;
#line 1937 "ClockApplet.c"
}

static void
clock_applet_finalize (GObject * obj)
{
	ClockApplet * self;
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOCK_APPLET, ClockApplet);
#line 22 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->widget);
#line 23 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->layout);
#line 24 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->clock_label);
#line 25 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->date_label);
#line 26 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->seconds_label);
#line 28 "../src/panel/applets/clock/ClockApplet.vala"
	_g_date_time_unref0 (self->priv->time);
#line 30 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->settings);
#line 31 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->gnome_settings);
#line 33 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (self->priv->popover);
#line 44 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (self->priv->clock_custom_format);
#line 45 "../src/panel/applets/clock/ClockApplet.vala"
	_g_time_zone_unref0 (self->priv->clock_timezone);
#line 47 "../src/panel/applets/clock/ClockApplet.vala"
	_g_free0 (self->priv->_uuid);
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	G_OBJECT_CLASS (clock_applet_parent_class)->finalize (obj);
#line 1972 "ClockApplet.c"
}

GType
clock_applet_get_type (void)
{
	return clock_applet_type_id;
}

GType
clock_applet_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClockAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClockApplet), 0, (GInstanceInitFunc) clock_applet_instance_init, NULL };
	clock_applet_type_id = g_type_module_register_type (module, budgie_applet_get_type (), "ClockApplet", &g_define_type_info, 0);
	ClockApplet_private_offset = sizeof (ClockAppletPrivate);
	return clock_applet_type_id;
}

static void
_vala_clock_applet_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ClockApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOCK_APPLET, ClockApplet);
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	switch (property_id) {
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
		case CLOCK_APPLET_UUID_PROPERTY:
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
		g_value_set_string (value, clock_applet_get_uuid (self));
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
		break;
#line 2006 "ClockApplet.c"
		default:
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
		break;
#line 2012 "ClockApplet.c"
	}
}

static void
_vala_clock_applet_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	ClockApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOCK_APPLET, ClockApplet);
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
	switch (property_id) {
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
		case CLOCK_APPLET_UUID_PROPERTY:
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
		clock_applet_set_uuid (self, g_value_get_string (value));
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
		break;
#line 2032 "ClockApplet.c"
		default:
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/panel/applets/clock/ClockApplet.vala"
		break;
#line 2038 "ClockApplet.c"
	}
}

static inline gpointer
clock_settings_get_instance_private (ClockSettings* self)
{
	return G_STRUCT_MEMBER_P (self, ClockSettings_private_offset);
}

static gboolean
__lambda7_ (GValue* value,
            GVariant* variant,
            void* user_data)
{
	const gchar* _tmp0_;
	gboolean result;
#line 374 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 374 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (variant != NULL, FALSE);
#line 375 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp0_ = g_variant_get_string (variant, NULL);
#line 375 "../src/panel/applets/clock/ClockApplet.vala"
	g_value_set_boolean (value, g_strcmp0 (_tmp0_, "24h") == 0);
#line 376 "../src/panel/applets/clock/ClockApplet.vala"
	result = TRUE;
#line 376 "../src/panel/applets/clock/ClockApplet.vala"
	return result;
#line 2067 "ClockApplet.c"
}

static gboolean
___lambda7__gsettings_bind_get_mapping (GValue* value,
                                        GVariant* variant,
                                        void* user_data)
{
	gboolean result;
	result = __lambda7_ (value, variant, user_data);
#line 374 "../src/panel/applets/clock/ClockApplet.vala"
	return result;
#line 2079 "ClockApplet.c"
}

static GVariant*
__lambda8_ (GValue* value,
            const GVariantType* expected_type,
            void* user_data)
{
	GVariant* _tmp1_;
	GVariant* result;
#line 377 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 377 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_val_if_fail (expected_type != NULL, NULL);
#line 378 "../src/panel/applets/clock/ClockApplet.vala"
	if (g_value_get_boolean (value)) {
#line 2095 "ClockApplet.c"
		GVariant* _tmp0_;
#line 379 "../src/panel/applets/clock/ClockApplet.vala"
		_tmp0_ = g_variant_new ("s", "24h", NULL);
#line 379 "../src/panel/applets/clock/ClockApplet.vala"
		g_variant_ref_sink (_tmp0_);
#line 379 "../src/panel/applets/clock/ClockApplet.vala"
		result = _tmp0_;
#line 379 "../src/panel/applets/clock/ClockApplet.vala"
		return result;
#line 2105 "ClockApplet.c"
	}
#line 381 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp1_ = g_variant_new ("s", "12h", NULL);
#line 381 "../src/panel/applets/clock/ClockApplet.vala"
	g_variant_ref_sink (_tmp1_);
#line 381 "../src/panel/applets/clock/ClockApplet.vala"
	result = _tmp1_;
#line 381 "../src/panel/applets/clock/ClockApplet.vala"
	return result;
#line 2115 "ClockApplet.c"
}

static GVariant*
___lambda8__gsettings_bind_set_mapping (GValue* value,
                                        const GVariantType* expected_type,
                                        void* user_data)
{
	GVariant* result;
	result = __lambda8_ (value, expected_type, user_data);
#line 374 "../src/panel/applets/clock/ClockApplet.vala"
	return result;
#line 2127 "ClockApplet.c"
}

static void
_clock_settings_updateSensitve_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 388 "../src/panel/applets/clock/ClockApplet.vala"
	clock_settings_updateSensitve ((ClockSettings*) self);
#line 2137 "ClockApplet.c"
}

ClockSettings*
clock_settings_construct (GType object_type,
                          GSettings* settings,
                          GSettings* gnome_settings)
{
	ClockSettings * self = NULL;
	GtkSwitch* _tmp0_;
	GtkSwitch* _tmp1_;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	GtkEntry* _tmp4_;
	GtkSwitch* _tmp5_;
	GtkEntry* _tmp6_;
	GtkSwitch* _tmp7_;
	GtkSwitch* _tmp8_;
#line 371 "../src/panel/applets/clock/ClockApplet.vala"
	self = (ClockSettings*) g_object_new (object_type, NULL);
#line 372 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->show_date;
#line 372 "../src/panel/applets/clock/ClockApplet.vala"
	g_settings_bind (settings, "show-date", (GObject*) _tmp0_, "active", G_SETTINGS_BIND_DEFAULT);
#line 373 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->show_seconds;
#line 373 "../src/panel/applets/clock/ClockApplet.vala"
	g_settings_bind (settings, "show-seconds", (GObject*) _tmp1_, "active", G_SETTINGS_BIND_DEFAULT);
#line 374 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp2_ = self->priv->use_24_hour_time;
#line 374 "../src/panel/applets/clock/ClockApplet.vala"
	g_settings_bind_with_mapping (gnome_settings, "clock-format", (GObject*) _tmp2_, "active", G_SETTINGS_BIND_DEFAULT, ___lambda7__gsettings_bind_get_mapping, ___lambda8__gsettings_bind_set_mapping, NULL, NULL);
#line 383 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp3_ = self->priv->use_custom_format;
#line 383 "../src/panel/applets/clock/ClockApplet.vala"
	g_settings_bind (settings, "use-custom-format", (GObject*) _tmp3_, "active", G_SETTINGS_BIND_DEFAULT);
#line 384 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp4_ = self->priv->custom_format;
#line 384 "../src/panel/applets/clock/ClockApplet.vala"
	g_settings_bind (settings, "custom-format", (GObject*) _tmp4_, "text", G_SETTINGS_BIND_DEFAULT);
#line 385 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp5_ = self->priv->use_custom_timezone;
#line 385 "../src/panel/applets/clock/ClockApplet.vala"
	g_settings_bind (settings, "use-custom-timezone", (GObject*) _tmp5_, "active", G_SETTINGS_BIND_DEFAULT);
#line 386 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp6_ = self->priv->custom_timezone;
#line 386 "../src/panel/applets/clock/ClockApplet.vala"
	g_settings_bind (settings, "custom-timezone", (GObject*) _tmp6_, "text", G_SETTINGS_BIND_DEFAULT);
#line 388 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp7_ = self->priv->use_custom_format;
#line 388 "../src/panel/applets/clock/ClockApplet.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::active", (GCallback) _clock_settings_updateSensitve_g_object_notify, self, 0);
#line 389 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp8_ = self->priv->use_custom_timezone;
#line 389 "../src/panel/applets/clock/ClockApplet.vala"
	g_signal_connect_object ((GObject*) _tmp8_, "notify::active", (GCallback) _clock_settings_updateSensitve_g_object_notify, self, 0);
#line 391 "../src/panel/applets/clock/ClockApplet.vala"
	clock_settings_updateSensitve (self);
#line 371 "../src/panel/applets/clock/ClockApplet.vala"
	return self;
#line 2197 "ClockApplet.c"
}

ClockSettings*
clock_settings_new (GSettings* settings,
                    GSettings* gnome_settings)
{
#line 371 "../src/panel/applets/clock/ClockApplet.vala"
	return clock_settings_construct (TYPE_CLOCK_SETTINGS, settings, gnome_settings);
#line 2206 "ClockApplet.c"
}

static void
clock_settings_updateSensitve (ClockSettings* self)
{
	gboolean useCustomFormat = FALSE;
	GtkSwitch* _tmp0_;
	GtkSwitch* _tmp1_;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	GtkEntry* _tmp4_;
	GtkEntry* _tmp5_;
	GtkSwitch* _tmp6_;
#line 394 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 395 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp0_ = self->priv->use_custom_format;
#line 395 "../src/panel/applets/clock/ClockApplet.vala"
	useCustomFormat = gtk_switch_get_active (_tmp0_);
#line 396 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp1_ = self->priv->show_date;
#line 396 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, !useCustomFormat);
#line 397 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp2_ = self->priv->show_seconds;
#line 397 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, !useCustomFormat);
#line 398 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp3_ = self->priv->use_24_hour_time;
#line 398 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, !useCustomFormat);
#line 399 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp4_ = self->priv->custom_format;
#line 399 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, useCustomFormat);
#line 401 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp5_ = self->priv->custom_timezone;
#line 401 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp6_ = self->priv->use_custom_timezone;
#line 401 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, gtk_switch_get_active (_tmp6_));
#line 2248 "ClockApplet.c"
}

static void
clock_settings_class_init (ClockSettingsClass * klass,
                           gpointer klass_data)
{
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	clock_settings_parent_class = g_type_class_peek_parent (klass);
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	g_type_class_adjust_private_offset (klass, &ClockSettings_private_offset);
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	G_OBJECT_CLASS (klass)->finalize = clock_settings_finalize;
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/solus-project/clock/settings.ui");
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_date", FALSE, ClockSettings_private_offset + G_STRUCT_OFFSET (ClockSettingsPrivate, show_date));
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_seconds", FALSE, ClockSettings_private_offset + G_STRUCT_OFFSET (ClockSettingsPrivate, show_seconds));
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "use_24_hour_time", FALSE, ClockSettings_private_offset + G_STRUCT_OFFSET (ClockSettingsPrivate, use_24_hour_time));
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "use_custom_format", FALSE, ClockSettings_private_offset + G_STRUCT_OFFSET (ClockSettingsPrivate, use_custom_format));
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "custom_format", FALSE, ClockSettings_private_offset + G_STRUCT_OFFSET (ClockSettingsPrivate, custom_format));
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "use_custom_timezone", FALSE, ClockSettings_private_offset + G_STRUCT_OFFSET (ClockSettingsPrivate, use_custom_timezone));
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "custom_timezone", FALSE, ClockSettings_private_offset + G_STRUCT_OFFSET (ClockSettingsPrivate, custom_timezone));
#line 2277 "ClockApplet.c"
}

static void
clock_settings_instance_init (ClockSettings * self,
                              gpointer klass)
{
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	self->priv = clock_settings_get_instance_private (self);
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2288 "ClockApplet.c"
}

static void
clock_settings_finalize (GObject * obj)
{
	ClockSettings * self;
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOCK_SETTINGS, ClockSettings);
#line 348 "../src/panel/applets/clock/ClockApplet.vala"
	G_OBJECT_CLASS (clock_settings_parent_class)->finalize (obj);
#line 2299 "ClockApplet.c"
}

GType
clock_settings_get_type (void)
{
	return clock_settings_type_id;
}

GType
clock_settings_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClockSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClockSettings), 0, (GInstanceInitFunc) clock_settings_instance_init, NULL };
	clock_settings_type_id = g_type_module_register_type (module, gtk_grid_get_type (), "ClockSettings", &g_define_type_info, 0);
	ClockSettings_private_offset = sizeof (ClockSettingsPrivate);
	return clock_settings_type_id;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 409 "../src/panel/applets/clock/ClockApplet.vala"
	return self ? g_object_ref (self) : NULL;
#line 2322 "ClockApplet.c"
}

void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* objmodule = NULL;
	PeasObjectModule* _tmp0_;
#line 407 "../src/panel/applets/clock/ClockApplet.vala"
	g_return_if_fail (module != NULL);
#line 407 "../src/panel/applets/clock/ClockApplet.vala"
	clock_plugin_register_type (module);
#line 407 "../src/panel/applets/clock/ClockApplet.vala"
	clock_applet_register_type (module);
#line 407 "../src/panel/applets/clock/ClockApplet.vala"
	clock_settings_register_type (module);
#line 409 "../src/panel/applets/clock/ClockApplet.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
#line 409 "../src/panel/applets/clock/ClockApplet.vala"
	objmodule = _tmp0_;
#line 410 "../src/panel/applets/clock/ClockApplet.vala"
	peas_object_module_register_extension_type (objmodule, budgie_plugin_get_type (), TYPE_CLOCK_PLUGIN);
#line 407 "../src/panel/applets/clock/ClockApplet.vala"
	_g_object_unref0 (objmodule);
#line 2346 "ClockApplet.c"
}

